Attribute VB_Name = "modServerList"
Option Explicit

Public Declare Function GetPrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Packet01 As String
Public Packet03 As String
Public Packet05 As String
Public Packet07 As String

Public CurrentSock As sockaddrTYPES
Public SockID As Long

Public ZoneIp(1 To 30000) As String
Public ZonePort(1 To 30000) As Integer
Public ZoneName(1 To 30000) As String
Public ZoneComment(1 To 30000) As String
Public ZoneNumPlayers(1 To 30000) As String
'public ZoneConnected(1 to 30000) As Boolean
'public ZonePingTime(1 to 30000) As Long
Public ZoneOnline(1 To 30000) As Boolean
Public NumZones As Integer

Public AutoDownloadEvent As String

Public Type PLZoneType
 PlayerName As String
 PlayerPassword As String
 Name As String
End Type
Public PLZone(0 To 30000) As PLZoneType 'Array 0 is used for the rest of the zones and 1 - 30000 for custom
Public PLZCount As Integer
Public PlayerNameList(1 To 30000) As String 'A player will want to have more than 1 alias. They'll be chosen from a combo box
Public PlayerPasswordList(1 To 30000) As String
Public PLNCount As Integer 'Count of player names/passwords

Public Type CLZoneType
 Channel As String
 Name As String
End Type
Public CLZone(0 To 30000) As CLZoneType
Public CLZCount As Integer
Public ChatChannelsList(1 To 30000) As String
Public CLCCount As Integer

Global SubSpacePriorityInZone As Long, SubSpacePriorityNotInZone As Long
Global OurAppPriorityInZone As Long, OurAppPriorityNotInZone As Long
Global EnablePriorities As Boolean

Public Function FillZero(RawText As String, DesiredLength As Long) As String
If DesiredLength <= Len(RawText) Then
 FillZero = Left(RawText, DesiredLength)
Else
 FillZero = RawText & String(DesiredLength - Len(RawText), Chr(0))
End If
End Function

Public Function FillX(RawText As String, DesiredLength As Long, CharX As String) As String
If DesiredLength <= Len(RawText) Then
 FillX = Left(RawText, DesiredLength)
Else
 FillX = RawText & String(DesiredLength - Len(RawText), CharX)
End If
End Function

Public Function TrimZero(ByVal RawText As String) As String
Dim L As Long
L = InStr(RawText, Chr(0))
If L > 0 Then
 TrimZero = Left(RawText, L - 1)
Else
 TrimZero = RawText
End If
End Function

Public Function StringToInt(RawText As String) As Integer
Dim I As Integer
CopyMemory I, ByVal RawText, 2
StringToInt = I
End Function

Public Function StringToLong(RawText As String) As Long
Dim L As Long
CopyMemory L, ByVal RawText, 4
StringToLong = L
End Function

Public Function LongToString(L As Long) As String
Dim S4 As String * 4
CopyMemory ByVal S4, L, 4
LongToString = S4
End Function

Public Function IntToString(I As Integer) As String
Dim S2 As String * 2
CopyMemory ByVal S2, I, 2
IntToString = S2
End Function

Public Function GetProfileString(Section As String, key As String, DefaultValue As String) As String
Dim S As String * 1024
Dim L As Long
L = GetPrivateProfileStringA(Section, key, DefaultValue, S, Len(S), App.Path + "\" + App.Title & ".ini")
GetProfileString = Left(S, L)
End Function

Public Sub PutProfileString(Section As String, key As String, Value As String)
WritePrivateProfileStringA Section, key, Value, App.Path + "\" + App.Title & ".ini"
End Sub

Sub UpdateEnablePriorities()
frmServerList.tmrChangePriorities.Enabled = EnablePriorities
End Sub
